# Release Notes v0.4.0 : Uncertainty Analysis

This release introduces uncertainty analysis and more support for OpenPSA expressions.


## Major Changes

- Uncertainty analysis with Monte Carlo method
- Automated performance testing
- Probability calculation performance optimization (up to 10x faster)
- The default number of series in probability calculations is set to 7 (conservative result with acceptable performance).
- cppclean code problem check
- Lowered cyclomatic complexity of the core code (CCN < 15)
- Bug fixes of wrong output into a file
- Bug fix in log-normal distribution
- OpenPSA MEF support additions:
    * Expressions:
         + Constant expressions
         + System mission time
         + Parameter
         + Random deviate (normal, log-normal, histogram, uniform, gamma, beta)
         + Built-in expressions (exponential with two parameters, exponential with four parameters, Weibull)
- More theory information in documentations.
- Re-introduction of deprecated Inhibit gate, Conditional and Undeveloped events.


## Deprecated Features

- Vote gate is renamed  to "atleast".


## Since v0.3.1

- 124 commits resulted in 120 files changed, 10455 insertions(+), 3244 deletions(-)
